#include<iostream>
#include<iomanip>
using namespace std;

struct Matice
{
	int n = 0;
	int m = 0;
	float **a = nullptr;
};

void zrus(Matice &mat)
{
	if (mat.a)
	{
		// dealokace:
		for (int i = 0; i < mat.n; i++) // zrusim jednotlive radky
			delete[] mat.a[i];
		delete[] mat.a;                 // zrusim pole ukazatelu na radky
	}
}

void vytvor(Matice &mat, int n, int m)
{
	if (mat.a != nullptr)
		zrus(mat);
	mat.m = m;
	mat.n = n;

	// alokace:
	mat.a = new float*[n]; // pole ukazatelu na radky
	for (int i = 0; i < n; i++)
		mat.a[i] = new float[m]; // jednotlive radky

	// inicializace na 0
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			mat.a[i][j] = 0;
}

void vypis(const Matice &mat)
{
	for (int i = 0; i < mat.n; i++)
	{
		for (int j = 0; j < mat.m; j++)
			cout << setw(3) << mat.a[i][j] << ' ';
		cout << endl;
	}
	cout << endl;

}

int main()
{
	int n, m;
	cout << "zadej pocet radku:" << endl;
	cin >> n;
	if (n <= 0)
		n = 1;

	cout << "zadej pocet sloupcu:" << endl;
	cin >> m;
	if (m <= 0)
		m = 1;

	Matice a;
	Matice b;

	// alokace
	vytvor(a, n, m);
	vytvor(b, n, m);

	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			b.a[i][j] = 3;
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			a.a[i][j] = i * j;

	vypis(a);
	vypis(b);

	// dealokace
	zrus(a);
	zrus(b);

	return 0;
}

